diff --git a/run/bfd2john.py b/run/bfd2john.py
index e899585981..ad18125ea4 100755
--- a/run/bfd2john.py
+++ b/run/bfd2john.py
@@ -38,13 +38,19 @@ def pcap_parser(fname):
                 continue
 
             authentication_type = ord(data[24])
+            salt = data[0:32].encode("hex")
 
-            if authentication_type == 2:  # Keyed MD5
+            if authentication_type == 2 or authentication_type == 3:  # Keyed MD5, Meticulous Keyed MD5
                 h = data[-16:].encode("hex")  # MD5 hash
-                salt = data[0:32].encode("hex")
+                # password needs to be padded to length 16 (password + ''.join(['\x00' * (16 - len(password))])),
+                # "netmd5" format automagically handles this ;)
                 sys.stdout.write("$netmd5$%s$%s\n" % (salt, h))
+            elif authentication_type == 4 or authentication_type == 5:  # Keyed SHA1, Meticulous Keyed SHA1
+                # http://tools.ietf.org/html/rfc5880
+                # password needs to be padded to length 20 (password + ''.join(['\x00' * (20 - len(password))])),
+                h = data[-20:].encode("hex")  # SHA1 hash
+                sys.stdout.write("$netsha1$%s$%s\n" % (salt, h))
             else:
-                # http://tools.ietf.org/html/rfc5880 (TODO)
                 assert 0
 
     f.close()
diff --git a/src/net_sha1_fmt_plug.c b/src/net_sha1_fmt_plug.c
index ae01956cb0..000378babf 100644
--- a/src/net_sha1_fmt_plug.c
+++ b/src/net_sha1_fmt_plug.c
@@ -38,14 +38,14 @@ john_register_one(&fmt_netsha1);
 #include "memdbg.h"
 
 #define FORMAT_LABEL            "net-sha1"
-#define FORMAT_NAME             "\"Keyed SHA1\" RIPv2, OSPF, BGP, SNMPv2"
+#define FORMAT_NAME             "\"Keyed SHA1\" BFD"
 #define FORMAT_TAG              "$netsha1$"
 #define TAG_LENGTH              (sizeof(FORMAT_TAG) - 1)
 #define ALGORITHM_NAME          "SHA1 32/" ARCH_BITS_STR
 #define BENCHMARK_COMMENT       ""
 #define BENCHMARK_LENGTH        0
 
-#define PLAINTEXT_LENGTH        16
+#define PLAINTEXT_LENGTH        20  // get this right ;)
 #define BINARY_SIZE             20
 #define BINARY_ALIGN            sizeof(ARCH_WORD_32)
 #define SALT_SIZE               sizeof(struct custom_salt)
@@ -55,10 +55,9 @@ john_register_one(&fmt_netsha1);
 #define HEXCHARS                "0123456789abcdef"
 
 static struct fmt_tests tests[] = {
-/* Mockup test vectors. Both these lines should be deleted once we get some
-   real test vectors */
-	{           "02020000ffff0003002c01145267d48d000000000000000000020000ac100100ffffff000000000000000001ffff0001$7236e720eaebe9eb3954c53db5cc19224a6cfeb3", "quagga"},
-	{FORMAT_TAG "02020000ffff0003002c01145267d48d000000000000000000020000ac100100ffffff000000000000000001ffff0001$71893ac93cb5511937d4a7189d390d14d9e013fd", "magnum"},
+	/* Real hashes from Cisco routers ;) */
+	{"$netsha1$20440a340000000100000000000f4240000f424000000000051c010000000001$709d3307304d790f58bf0a3cefd783b438408996", "password12345"},
+	{"$netsha1$20440a340000000100000000000f4240000f424000000000051c010000000002$94bce4d9084199508669b39f044064082a093de3", "password12345"},
 	{NULL}
 };
 
@@ -141,14 +140,13 @@ static void *get_salt(char *ciphertext)
 		cs.salt[i] = (atoi16[ARCH_INDEX(ciphertext[2 * i])] << 4) |
 			atoi16[ARCH_INDEX(ciphertext[2 * i + 1])];
 
-	if (len < 230) {
+	if (0 && len < 230) { // XXX disable "dynamic" since I can't get it to work!
 		// return our memset buffer (putting the dyna salt pointer into it).
 		// This keeps teh 'pre-cleaned salt() warning from hitting this format)
 		//return pDynamicFmt->methods.salt(Convert(Conv_Buf, orig_ct));
 		memcpy((char*)(&cs), pDynamicFmt->methods.salt(Convert(Conv_Buf, orig_ct)), pDynamicFmt->params.salt_size);
 		dyna_salt_seen=1;
 		return &cs;
-		
 	}
 	cs.magic = MAGIC;
 	cs.length = len;
